package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.Objects;

/**
 * At most two types of interference data are reported in Inter, sorted in descending order of interference intensity
 */
@ApiModel(description = "At most two types of interference data are reported in Inter, sorted in descending order of interference intensity")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class Interference   {
  @JsonProperty("inf")
  private Integer inf;

  @JsonProperty("infType")
  private Integer infType;

  @JsonProperty("infData")
  private InterferenceDataEntity infData;

  public Interference inf(Integer inf) {
    this.inf = inf;
    return this;
  }

  /**
   * Interference should be within the range of -96 ~ -48
   * @return inf
  */
  @ApiModelProperty(value = "Interference should be within the range of -96 ~ -48")


  public Integer getInf() {
    return inf;
  }

  public void setInf(Integer inf) {
    this.inf = inf;
  }

  public Interference infType(Integer infType) {
    this.infType = infType;
    return this;
  }

  /**
   * Interference Type should be a value as follows: 0: invalid parameter; 1: MWO; 2: CW; 3: WLAN; 4: FHSS.
   * @return infType
  */
  @ApiModelProperty(value = "Interference Type should be a value as follows: 0: invalid parameter; 1: MWO; 2: CW; 3: WLAN; 4: FHSS.")


  public Integer getInfType() {
    return infType;
  }

  public void setInfType(Integer infType) {
    this.infType = infType;
  }

  public Interference infData(InterferenceDataEntity infData) {
    this.infData = infData;
    return this;
  }

  /**
   * Get infData
   * @return infData
  */
  @ApiModelProperty(value = "")

  @Valid

  public InterferenceDataEntity getInfData() {
    return infData;
  }

  public void setInfData(InterferenceDataEntity infData) {
    this.infData = infData;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Interference interference = (Interference) o;
    return Objects.equals(this.inf, interference.inf) &&
        Objects.equals(this.infType, interference.infType) &&
        Objects.equals(this.infData, interference.infData);
  }

  @Override
  public int hashCode() {
    return Objects.hash(inf, infType, infData);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Interference {\n");
    
    sb.append("    inf: ").append(toIndentedString(inf)).append("\n");
    sb.append("    infType: ").append(toIndentedString(infType)).append("\n");
    sb.append("    infData: ").append(toIndentedString(infData)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

